package com.sample;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.test.JbpmJUnitBaseTestCase;
import org.junit.Test;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.manager.RuntimeManager;
import org.kie.api.runtime.process.ProcessInstance;

/**
 * This is a sample file to test a process.
 */
public class ProcessTest extends JbpmJUnitBaseTestCase {

	@Test
	public void testProcess() {
		//Uncomment this line to test "rewards-basic_msg.bpmn2" process
//		RuntimeManager manager = createRuntimeManager("rewards-basic_msg.bpmn2");
		
		//Uncomment this line to test "sample_doublemessagesignal.bpmn2" process
		RuntimeManager manager = createRuntimeManager("sample_doublemessagesignal.bpmn2");
		
		//Uncomment this line to test "sample_doublesignal.bpmn2" process
//		RuntimeManager manager = createRuntimeManager("sample_doublesignal.bpmn2");
		
		RuntimeEngine engine = getRuntimeEngine(null);
		KieSession ksession = engine.getKieSession();
		Map<String,Object> processVariable = new HashMap<String,Object> ();
		processVariable.put("p_result", "JUST_STARTED");
		
		//Here using this id "com.sample.rewards-basic_msg" to test any of the "rewards-basic_msg.bpmn2" or "sample_doublesignal.bpmn2" or "sample_doublemessagesignal.bpmn2" processes
		ProcessInstance processInstance = ksession.startProcess("com.sample.rewards-basic_msg", processVariable);
		System.out.println("Parent Process ID: " + processInstance.getId());

		//Uncomment the following couple of lines to test "rewards-basic_msg.bpmn2" process
//		ksession.signalEvent("Message-TestMessage1","Test",processInstance.getId());
//		ksession.signalEvent("Message-TestMessage2","Test",processInstance.getId());
		
		//Uncomment the following line to test "sample_doublemessagesignal.bpmn2" process	
		ksession.signalEvent("Message-TestMessage","Test",processInstance.getId());
		
		//Uncomment the following line to test "sample_doublesignal.bpmn2" process	
//		ksession.signalEvent("Signal1","Test",processInstance.getId());
		
		manager.disposeRuntimeEngine(engine);
		manager.close();
	}

}